## libjodycode 3.1

=== Makefile ===
# libjodycode Makefile

CFLAGS ?= -O2 -g
PREFIX ?= /usr/local
PROGRAM_NAME = libjodycode
LIB_DIR ?= $(PREFIX)/lib
INC_DIR ?= $(PREFIX)/include
MAN_BASE_DIR ?= $(PREFIX)/share/man
MAN7_DIR ?= $(MAN_BASE_DIR)/man7
CC ?= gcc
INSTALL = install
RM      = rm -f
LN      = ln -sf
RMDIR   = rmdir -p
MKDIR   = mkdir -p
INSTALL_PROGRAM = $(INSTALL) -m 0755
INSTALL_DATA    = $(INSTALL) -m 0644
SO_SUFFIX = so
API_VERSION = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/\..*//')

# Make Configuration
COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
COMPILER_OPTIONS += -std=gnu11 -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe -fPIC

UNAME_S       = $(shell uname -s)
UNAME_M       = $(shell uname -m)
VERSION       = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/".*//')
VERSION_MAJOR = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/\..*//')
CROSS_DETECT  = $(shell true | $(CC) -dM -E - | grep -m 1 __x86_64 || echo "cross")

ifeq ($(UNAME_S), Darwin)
	LINK_OPTIONS += -Wl,-install_name,$(PROGRAM_NAME).$(SO_SUFFIX).$(API_VERSION)
else
	LINK_OPTIONS += -Wl,-soname,$(PROGRAM_NAME).$(SO_SUFFIX).$(API_VERSION)
endif

# Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
ifeq ($(UNAME_S), Darwin)
	GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
else
	GCCVERSION = 1
endif
ifeq ($(GCCVERSION), 1)
	COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
endif

# Are we running on a Windows OS?
ifeq ($(OS), Windows_NT)
	ifndef NO_WINDOWS
		ON_WINDOWS=1
		SO_SUFFIX=dll
	endif
endif

# Debugging code inclusion
ifdef LOUD
DEBUG=1
CFLAGS += -DLOUD_DEBUG
endif
ifdef DEBUG
CFLAGS += -DDEBUG
else
CFLAGS += -DNDEBUG
endif
ifdef HARDEN
CFLAGS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wl,-z,relro -Wl,-z,now
endif

# MinGW needs this for printf() conversions to work
ifdef ON_WINDOWS
	ifndef NO_UNICODE
		UNICODE=1
		COMPILER_OPTIONS += -municode
		PROGRAM_SUFFIX=.exe
	endif
	ifeq ($(UNAME_S), MINGW32_NT-5.1)
		OBJS += winres_xp.o
	else
		OBJS += winres.o
	endif
	COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1 -DON_WINDOWS=1
endif

# Do not build SIMD code if not on x86_64
ifneq ($(UNAME_M), x86_64)
NO_SIMD=1
endif
ifeq ($(CROSS_DETECT), cross)
NO_SIMD=1
endif

# SIMD SSE2/AVX2 jody_hash code
ifdef NO_SIMD
COMPILER_OPTIONS += -DNO_SIMD -DNO_SSE2 -DNO_AVX2
else
SIMD_OBJS += jody_hash_simd.o
ifdef NO_SSE2
COMPILER_OPTIONS += -DNO_SSE2
else
SIMD_OBJS += jody_hash_sse2.o
endif
ifdef NO_AVX2
COMPILER_OPTIONS += -DNO_AVX2
else
SIMD_OBJS += jody_hash_avx2.o
endif
endif


CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
LDFLAGS += $(LINK_OPTIONS)

# ADDITIONAL_OBJECTS - some platforms will need additional object files
# to support features not supplied by their vendor. Eg: GNU getopt()
#ADDITIONAL_OBJECTS += getopt.o

OBJS += alarm.o cacheinfo.o error.o jc_block_hash.o jody_hash.o
OBJS += oom.o paths.o size_suffix.o sort.o string.o
OBJS += strtoepoch.o version.o win_stat.o win_unicode.o
OBJS += $(ADDITIONAL_OBJECTS)

all: sharedlib staticlib
	-@test "$(CROSS_DETECT)" = "cross" && echo "NOTICE: SIMD disabled: !x86_64 or a cross-compiler detected (CC = $(CC))" || true

sharedlib: $(OBJS) $(SIMD_OBJS)
	$(CC) -shared -o $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION) $(OBJS) $(SIMD_OBJS) $(LDFLAGS) $(CFLAGS) $(CFLAGS_EXTRA)
	$(LN)            $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR)
	$(LN)            $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR) $(PROGRAM_NAME).$(SO_SUFFIX)

staticlib: $(OBJS) $(SIMD_OBJS)
	$(AR) rcs libjodycode.a $(OBJS) $(SIMD_OBJS)

jody_hash_simd.o:
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -mavx2 -c -o jody_hash_simd.o jody_hash_simd.c

jody_hash_avx2.o: jody_hash_simd.o
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -mavx2 -c -o jody_hash_avx2.o jody_hash_avx2.c

jody_hash_sse2.o: jody_hash_simd.o
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -msse2 -c -o jody_hash_sse2.o jody_hash_sse2.c

apiver:
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -o apiver helper_code/libjodycode_apiver.c

vercheck: helper_code/libjodycode_check.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -DJC_TEST -I. -c -o vercheck.o helper_code/libjodycode_check.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -L. -Wl,-Bstatic vercheck.o -ljodycode -Wl,-Bdynamic -o vercheck

.c.o:
	$(CC) -c $(COMPILER_OPTIONS) $(CFLAGS) $(CPPFLAGS) $< -o $@

#manual:
#	gzip -9 < jodycode.8 > jodycode.8.gz

$(PROGRAM_NAME): jodyhash $(OBJS)
#	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)

winres.o: winres.rc winres.manifest.xml
	./tune_winres.sh
	windres winres.rc winres.o

winres_xp.o: winres_xp.rc
	./tune_winres.sh
	windres winres_xp.rc winres_xp.o

installdirs:
	test -e $(DESTDIR)$(LIB_DIR) || $(MKDIR) $(DESTDIR)$(LIB_DIR)
	test -e $(DESTDIR)$(INC_DIR) || $(MKDIR) $(DESTDIR)$(INC_DIR)
	test -e $(DESTDIR)$(MAN7_DIR) || $(MKDIR) $(DESTDIR)$(MAN7_DIR)

installfiles:
	$(INSTALL_PROGRAM) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)            $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)
	$(LN)           $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR)
	$(LN)           $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX)
	$(INSTALL_DATA) $(PROGRAM_NAME).a  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).a
	$(INSTALL_DATA) $(PROGRAM_NAME).h  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
	$(INSTALL_DATA) $(PROGRAM_NAME).7  $(DESTDIR)$(MAN7_DIR)/$(PROGRAM_NAME).7

install: installdirs installfiles

uninstalldirs:
	-test -e $(DESTDIR)$(LIB_DIR)  && $(RMDIR) $(DESTDIR)$(LIB_DIR)
	-test -e $(DESTDIR)$(INC_DIR)  && $(RMDIR) $(DESTDIR)$(INC_DIR)
	-test -e $(DESTDIR)$(MAN7_DIR) && $(RMDIR) $(DESTDIR)$(MAN7_DIR)

uninstallfiles:
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).a
	$(RM)  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
	$(RM)  $(DESTDIR)$(MAN7_DIR)/$(PROGRAM_NAME).7

uninstall: uninstallfiles uninstalldirs

test:
	./test.sh

stripped: sharedlib staticlib
	strip --strip-unneeded libjodycode.$(SO_SUFFIX)
	strip --strip-debug libjodycode.a

objsclean:
	$(RM) $(OBJS) $(SIMD_OBJS) vercheck.o

clean: objsclean
	$(RM) $(PROGRAM_NAME).$(SO_SUFFIX) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)
	$(RM) apiver vercheck *.a *~ helper_code/*~ libjodycode.so.* libjodycode.dll.* .*.un~ *.gcno *.gcda *.gcov

distclean: objsclean clean
	$(RM) *.pkg.tar.*
	$(RM) -r $(PROGRAM_NAME)-*-*/ $(PROGRAM_NAME)-*-*.zip

chrootpackage:
	+./chroot_build.sh
package:
	+./generate_packages.sh

=== debian/changelog ===
libjodycode (3.1-3~bpo12+1) bookworm-backports; urgency=medium

  * Rebuild for bookworm-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 24 Jul 2023 10:03:08 -0300

libjodycode (3.1-3) unstable; urgency=medium

  [ Joao Eriberto Mota Filho ]
  * debian/copyright: added Pino Toscano to debian/* block.

  [ Pino Toscano ]
  * debian/libjodycode3.symbols: mark the jc_get_proc_cacheinfo symbol as
    linux-any, as that function is implemented only on Linux.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 12 Jul 2023 15:41:42 -0300

libjodycode (3.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 08 Jul 2023 10:57:05 -0300

libjodycode (3.1-1) experimental; urgency=medium

  * New upstream version 3.1.
  * debian/patches/010_add-GCC-hardening.patch: removed because the upstream
    fixed the source code. Thanks!

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 07 Jul 2023 13:19:44 -0300

libjodycode (3.0.1-4) unstable; urgency=medium

  * Upload to unstable.
  * debian/patches/010_add-GCC-hardening.patch: fixed the Forwarded field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 24 Jun 2023 08:15:14 -0300

libjodycode (3.0.1-3) experimental; urgency=medium

  * Solving some mistakes in packaging of this lib. Consequently:
      - debian/control:
          ~ Dropped transitional packages libjodycode2-dev and libjodycode2.
          ~ Renamed libjodycode3-dev to libjodycode-dev.
      - debian/libjodycode3-dev.install: renamed to libjodycode-dev.install.
      - debian/libjodycode3.symbols: updated the Build-Depends-Package field.
      - Thanks to Adrian Bunk <bunk@debian.org>.
      - Closes: #1038752

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Wed, 21 Jun 2023 23:26:52 -0300

libjodycode (3.0.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 20 Jun 2023 07:24:12 -0300

libjodycode (3.0.1-1) experimental; urgency=medium

  * New upstream version 3.0.1.
  * The upstream renamed libjodycode2 to libjodycode3. Consequently:
      - debian/control:
          ~ Created new stanzas for the new binaries libjodycode3 and
            libjodycode3-dev.
          ~ Transformed the old stanzas libjodycode2 and libjodycode2-dev
            in transitional dummy packages.
      - debian/libjodycode2-dev.install: renamed to
        debian/libjodycode3-dev.install.
      - debian/libjodycode2.docs: renamed to debian/libjodycode3.docs.
      - debian/libjodycode2.install: renamed to debian/libjodycode3.install.
      - debian/libjodycode2.symbols:
          ~ Renamed to debian/libjodycode3.symbols.
          ~ Regenerated all symbols.
  * debian/control: set libjodycode3-dev as 'Multi-Arch: same'.
  * debian/copyright: updated data about upstream copyright. Details:
      - Added orig_headers/jody_oom.h to "CC0-1.0 or Public-Domain" stanza.
      - Created a new stanza called "Public Domain" for files
        helper_code/libjodycode_apiver.c and likely_unlikely.h.
      - Removed oom.c from the "CC0-1.0 or Public-Domain" stanza because the
        upstream re-licensed this file to Expat.
  * debian/patches/010_add-GCC-hardening.patch: updated. The upstream fixed the
    source code, but the new version of the lib needs a new adjustment.
  * debian/rules: re-enabled the dh_auto_test and installation of the manpage
    because the upstream fixed the source code. Thanks!
  * debian/tests/control:
      - Bumped the jdupes relationship to 1.25.0-1.
      - Depending explicitly of the libjodycode3.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 18 Jun 2023 14:34:56 -0300

libjodycode (2.0.1-4) unstable; urgency=medium

  * Added CI tests using jdupes command to call libjodycode. Consequently:
      - debian/source/include-binaries: created to allow binaries in CI tests.
      - debian/tests/*: created to provide CI tests.
  * debian/control: set libjodycode2 as 'Multi-Arch: same'.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 17 Jun 2023 00:57:51 -0300

libjodycode (2.0.1-3) unstable; urgency=medium

  * debian/libjodycode2.symbols: set four symbols as optional because they
    seem specific for amd64. Optional is better than amd64 because this makes
    these symbols not so restricts.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 15 Jun 2023 19:08:45 -0300

libjodycode (2.0.1-2) unstable; urgency=medium

  * Upload to unstable.
  * debian/libjodycode2.symbols: temporarily disabled the symbol tags to
    discover the issues for each architecture.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 15 Jun 2023 13:35:30 -0300

libjodycode (2.0.1-1) experimental; urgency=medium

  * Initial release. (Closes: #1037451)

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 12 Jun 2023 20:41:03 -0300

=== debian/control ===
Source: libjodycode
Section: libs
Priority: optional
Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
Rules-Requires-Root: no
Build-Depends: debhelper-compat (= 13)
Standards-Version: 4.6.2
Homepage: https://github.com/jbruchon/libjodycode
Vcs-Browser: https://salsa.debian.org/debian/libjodycode
Vcs-Git: https://salsa.debian.org/debian/libjodycode.git

Package: libjodycode3
Architecture: any
Multi-Arch: same
Depends: ${shlibs:Depends}, ${misc:Depends}
Replaces: libjodycode2 (<= 2.0.1-4)
Breaks: libjodycode2 (<= 2.0.1-4)
Description: shared lib for programs written by Jody Bruchon (runtime)
 libjodycode is a software code library containing code shared among several
 of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
 and zeromerge. These shared pieces of code were copied between each program
 as they were updated. As the number of programs increased and keeping these
 pieces of code synced became more annoying, the decision was made to combine
 all of them into a single reusable shared library.
 .
 This package provides the runtime for libjodycode.

Package: libjodycode-dev
Architecture: any
Multi-Arch: same
Section: libdevel
Depends: ${misc:Depends}, libjodycode3 (= ${binary:Version})
Replaces: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
Breaks: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
Description: shared lib for programs written by Jody Bruchon (development files)
 libjodycode is a software code library containing code shared among several
 of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
 and zeromerge. These shared pieces of code were copied between each program
 as they were updated. As the number of programs increased and keeping these
 pieces of code synced became more annoying, the decision was made to combine
 all of them into a single reusable shared library.
 .
 This package provides the development files for libjodycode.

=== debian/tests/control ===
Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@1AHiprls $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/ | grep -C50 list1| grep -C50 list7
Depends: libjodycode3, jdupes (>= 1.25.0-1), tree:native

Test-Command: cp -a debian/tests/files/ $AUTOPKGTEST_TMP;
              jdupes -@rdNQzo time  -X size+:15 $AUTOPKGTEST_TMP/files;
              tree -C $AUTOPKGTEST_TMP/ | grep -C50 files
Depends: libjodycode3, jdupes (>= 1.25.0-1), tree:native
Restrictions: allow-stderr

=== debian/watch ===
version=4
https://github.com/jbruchon/libjodycode/tags .*/tags/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## libjodycode 3.1.1

=== Makefile ===
--- 
+++ 
@@ -30,19 +30,20 @@
 CROSS_DETECT  = $(shell true | $(CC) -dM -E - | grep -m 1 __x86_64 || echo "cross")
 
 ifeq ($(UNAME_S), Darwin)
-	LINK_OPTIONS += -Wl,-install_name,$(PROGRAM_NAME).$(SO_SUFFIX).$(API_VERSION)
-else
-	LINK_OPTIONS += -Wl,-soname,$(PROGRAM_NAME).$(SO_SUFFIX).$(API_VERSION)
-endif
-
-# Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
-ifeq ($(UNAME_S), Darwin)
-	GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep 'gcc version ' | cut -d\  -f3 | cut -d. -f1` \>= 5)
-else
-	GCCVERSION = 1
-endif
+ LINK_OPTIONS += -Wl,-install_name,$(PROGRAM_NAME).$(SO_SUFFIX).$(API_VERSION)
+ # Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
+ GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep '[cn][cg] version' | sed 's/[^0-9]*//;s/[ .].*//'` \>= 5)
+ STRIP_UNNEEDED = strip -S
+ STRIP_DEBUG = strip -S
+else
+ LINK_OPTIONS += -Wl,-soname,$(PROGRAM_NAME).$(SO_SUFFIX).$(API_VERSION)
+ GCCVERSION = 1
+ STRIP_UNNEEDED = strip --strip-unneeded
+ STRIP_DEBUG = strip --strip-debug
+endif
+
 ifeq ($(GCCVERSION), 1)
-	COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
+ COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
 endif
 
 # Are we running on a Windows OS?
@@ -147,6 +148,9 @@
 	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -DJC_TEST -I. -c -o vercheck.o helper_code/libjodycode_check.c
 	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -L. -Wl,-Bstatic vercheck.o -ljodycode -Wl,-Bdynamic -o vercheck
 
+cacheinfo:
+	$(CC) cacheinfo.c -DJC_TEST $(CFLAGS) $(LDFLAGS) -o cacheinfo
+
 .c.o:
 	$(CC) -c $(COMPILER_OPTIONS) $(CFLAGS) $(CPPFLAGS) $< -o $@
 
@@ -169,7 +173,7 @@
 	test -e $(DESTDIR)$(INC_DIR) || $(MKDIR) $(DESTDIR)$(INC_DIR)
 	test -e $(DESTDIR)$(MAN7_DIR) || $(MKDIR) $(DESTDIR)$(MAN7_DIR)
 
-installfiles:
+installfiles: installdirs
 	$(INSTALL_PROGRAM) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)            $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)
 	$(LN)           $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR)
 	$(LN)           $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME).$(SO_SUFFIX)
@@ -198,15 +202,16 @@
 	./test.sh
 
 stripped: sharedlib staticlib
-	strip --strip-unneeded libjodycode.$(SO_SUFFIX)
-	strip --strip-debug libjodycode.a
+	$(STRIP_UNNEEDED) libjodycode.$(SO_SUFFIX)
+	$(STRIP_DEBUG) libjodycode.a
 
 objsclean:
 	$(RM) $(OBJS) $(SIMD_OBJS) vercheck.o
 
 clean: objsclean
 	$(RM) $(PROGRAM_NAME).$(SO_SUFFIX) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION_MAJOR) $(PROGRAM_NAME).$(SO_SUFFIX).$(VERSION)
-	$(RM) apiver vercheck *.a *~ helper_code/*~ libjodycode.so.* libjodycode.dll.* .*.un~ *.gcno *.gcda *.gcov
+	$(RM) apiver cacheinfo vercheck
+	$(RM) *.a *~ helper_code/*~ libjodycode.so.* libjodycode.dll.* .*.un~ *.gcno *.gcda *.gcov
 
 distclean: objsclean clean
 	$(RM) *.pkg.tar.*

=== debian/changelog ===
libjodycode (3.1.1-2deepin1) unstable; urgency=medium

  * Revert 64-bit time_t changes.

 -- Tianyu Chen <sweetyfish@deepin.org>  Fri, 21 Feb 2025 16:31:55 +0800

libjodycode (3.1.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 02 Aug 2024 14:35:24 -0300

libjodycode (3.1.1-1) experimental; urgency=medium

  * New upstream version 3.1.1.
  * debian/control: bumped Standards-Version to 4.7.0.
  * debian/copyright:
      - Added new rights in packaging stanza.
      - Removed a reference for orig_headers/jody_oom.h, no longer in source
        code.
      - Updated upstream and packaging copyright years.
  * debian/libjodycode3t64.lintian-overrides: removed. The upstream fixed the
    source code. Thanks!
  * debian/libjodycode3t64.symbols: added a new symbol.
  * debian/tests/control: using libjodycode3t64 as dependency. Thanks to
    Matthias Klose <doko@ubuntu.com>.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 02 Aug 2024 00:49:01 -0300

libjodycode (3.1-6.1) unstable; urgency=medium

  * Non-maintainer upload.
  * Rename libraries for 64-bit time_t transition.  Closes: #1062385

 -- Benjamin Drung <bdrung@debian.org>  Wed, 28 Feb 2024 13:29:05 +0000

libjodycode (3.1-6) unstable; urgency=medium

  * jdupes has a new repository (Codeberg). Consequently:
      - debian/control: updated the Homepage field.
      - debian/copyright: updated Upstream-Contact and Source fields.
      - debian/upstream/metadata: updated all data.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 14 Nov 2023 10:54:49 -0300

libjodycode (3.1-5) unstable; urgency=medium

  * debian/watch: updated because the upstream moved the project from GitHub
    to Codeberg.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Fri, 06 Oct 2023 21:56:55 -0300

libjodycode (3.1-4) unstable; urgency=medium

  * debian/libjodycode3.symbols: changed the tags of the last four symbols from
    "optional" to "arch=amd64".

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 08 Aug 2023 12:52:16 -0300

=== debian/control ===
--- 
+++ 
@@ -4,8 +4,8 @@
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Rules-Requires-Root: no
 Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.6.2
-Homepage: https://github.com/jbruchon/libjodycode
+Standards-Version: 4.7.0
+Homepage: https://codeberg.org/jbruchon/libjodycode
 Vcs-Browser: https://salsa.debian.org/debian/libjodycode
 Vcs-Git: https://salsa.debian.org/debian/libjodycode.git

## libjodycode 3.1.2

=== debian/control ===
--- 
+++ 
@@ -3,18 +3,19 @@
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
 Rules-Requires-Root: no
-Build-Depends: debhelper-compat (= 13)
-Standards-Version: 4.7.0
+Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
+Standards-Version: 4.7.2
 Homepage: https://codeberg.org/jbruchon/libjodycode
 Vcs-Browser: https://salsa.debian.org/debian/libjodycode
 Vcs-Git: https://salsa.debian.org/debian/libjodycode.git
 
-Package: libjodycode3
+Package: libjodycode3t64
+Provides: ${t64:Provides}
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: libjodycode2 (<= 2.0.1-4)
-Breaks: libjodycode2 (<= 2.0.1-4)
+Replaces: libjodycode3, libjodycode2 (<= 2.0.1-4)
+Breaks: libjodycode3 (<< ${source:Version}), libjodycode2 (<= 2.0.1-4)
 Description: shared lib for programs written by Jody Bruchon (runtime)
  libjodycode is a software code library containing code shared among several
  of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
@@ -29,7 +30,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, libjodycode3 (= ${binary:Version})
+Depends: ${misc:Depends}, libjodycode3t64 (= ${binary:Version})
 Replaces: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
 Breaks: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
 Description: shared lib for programs written by Jody Bruchon (development files)

## libjodycode 4.0.1

=== Makefile ===
# libjodycode Makefile

CFLAGS ?= -O2 -g
PREFIX ?= /usr/local
PROGRAM_NAME = libjodycode
LIB_DIR ?= $(PREFIX)/lib
INC_DIR ?= $(PREFIX)/include
MAN_BASE_DIR ?= $(PREFIX)/share/man
MAN7_DIR ?= $(MAN_BASE_DIR)/man7
CC ?= gcc
INSTALL = install
RM      = rm -f
LN      = ln -sf
RMDIR   = rmdir -p
MKDIR   = mkdir -p
INSTALL_PROGRAM = $(INSTALL) -m 0755
INSTALL_DATA    = $(INSTALL) -m 0644
SO_SUFFIX = .so
LIB_SUFFIX = .a

# Make Configuration
COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
COMPILER_OPTIONS += -std=gnu11 -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe -fPIC

UNAME_S       = $(shell uname -s)
UNAME_M       = $(shell uname -m)
VERSION       = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/".*//')
VERSION_MAJOR = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/\..*//')
SO_VER_FULL   =$(SO_SUFFIX).$(VERSION)
SO_VER_MAJOR  =$(SO_SUFFIX).$(VERSION_MAJOR)
CROSS_DETECT  = $(shell true | $(CC) -dM -E - | grep -m 1 __x86_64 || echo "cross")

# Are we running on a Windows OS?
ifeq ($(OS), Windows_NT)
 ifndef NO_WINDOWS
  ON_WINDOWS=1
  SO_SUFFIX=.dll
  LIB_SUFFIX=.lib
  SO_VER_FULL=$(SO_SUFFIX)
  SO_VER_MAJOR=$(SO_SUFFIX)
 endif
endif

ifeq ($(UNAME_S), Darwin)
 SO_SUFFIX    = .dylib
 SO_VER_FULL  = .$(VERSION)$(SO_SUFFIX)
 SO_VER_MAJOR = .$(VERSION_MAJOR)$(SO_SUFFIX)
 LINK_OPTIONS += -Wl,-install_name,$(PROGRAM_NAME)$(SO_VER_MAJOR)
 # Don't use unsupported compiler options on gcc 3/4 (Mac OS X 10.5.8 Xcode)
 GCCVERSION = $(shell expr `LC_ALL=C gcc -v 2>&1 | grep '[cn][cg] version' | sed 's/[^0-9]*//;s/[ .].*//'` \>= 5)
 STRIP_UNNEEDED = strip -S
 STRIP_DEBUG = strip -S
else
 LINK_OPTIONS += -Wl,-soname,$(PROGRAM_NAME)$(SO_VER_MAJOR)
 GCCVERSION = 1
 STRIP_UNNEEDED = strip --strip-unneeded
 STRIP_DEBUG = strip --strip-debug
endif

ifeq ($(GCCVERSION), 1)
 COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
endif

# Debugging code inclusion
ifdef LOUD
 DEBUG=1
 CFLAGS += -DLOUD_DEBUG
endif
ifdef DEBUG
 CFLAGS += -DDEBUG
else
 CFLAGS += -DNDEBUG
endif
ifdef HARDEN
 CFLAGS += -Wformat -Wformat-security -D_FORTIFY_SOURCE=2 -fstack-protector-strong -Wl,-z,relro -Wl,-z,now
endif

# MinGW needs this for printf() conversions to work
ifdef ON_WINDOWS
 ifndef NO_UNICODE
  UNICODE=1
  COMPILER_OPTIONS += -municode
  PROGRAM_SUFFIX=.exe
 endif
 ifeq ($(UNAME_S), MINGW32_NT-5.1)
  OBJS += winres_xp.o
 else
  OBJS += winres.o
 endif
# COMPILER_OPTIONS += -D__USE_MINGW_ANSI_STDIO=1
 COMPILER_OPTIONS += -DON_WINDOWS=1
endif

# Do not build SIMD code if not on x86_64
ifneq ($(UNAME_M), x86_64)
 NO_SIMD=1
endif
ifeq ($(CROSS_DETECT), cross)
 NO_SIMD=1
endif

# SIMD SSE2/AVX2 jody_hash code
ifdef NO_SIMD
 COMPILER_OPTIONS += -DNO_SIMD -DNO_SSE2 -DNO_AVX2
else
 SIMD_OBJS += jody_hash_simd.o
 ifdef NO_SSE2
  COMPILER_OPTIONS += -DNO_SSE2
 else
  SIMD_OBJS += jody_hash_sse2.o
 endif
 ifdef NO_AVX2
  COMPILER_OPTIONS += -DNO_AVX2
 else
  SIMD_OBJS += jody_hash_avx2.o
 endif
endif


CFLAGS += $(COMPILER_OPTIONS) $(CFLAGS_EXTRA)
LDFLAGS += $(LINK_OPTIONS)

# ADDITIONAL_OBJECTS - some platforms will need additional object files
# to support features not supplied by their vendor. Eg: GNU getopt()
#ADDITIONAL_OBJECTS += getopt.o

OBJS += access.o alarm.o batch.o block_hash.o cacheinfo.o dir.o
OBJS += error.o fopen.o jc_fwprint.o getcwd.o jody_hash.o link.o
OBJS += linkfiles.o numstrcmp.o oom.o paths.o
OBJS += remove.o rename.o size_suffix.o stat.o
OBJS += string.o time.o version.o win_unicode.o
OBJS += $(ADDITIONAL_OBJECTS)

all: sharedlib staticlib
	-@test "$(CROSS_DETECT)" = "cross" && echo "NOTICE: SIMD disabled: !x86_64 or a cross-compiler detected (CC = $(CC))" || true

sharedlib: $(OBJS) $(SIMD_OBJS)
	$(CC) -shared -o $(PROGRAM_NAME)$(SO_VER_FULL) $(OBJS) $(SIMD_OBJS) $(LDFLAGS) $(CFLAGS) $(CFLAGS_EXTRA)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_FULL) $(PROGRAM_NAME)$(SO_VER_MAJOR)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(PROGRAM_NAME)$(SO_SUFFIX)

staticlib: $(OBJS) $(SIMD_OBJS)
	$(AR) rcs libjodycode$(LIB_SUFFIX) $(OBJS) $(SIMD_OBJS)

jody_hash_simd.o:
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -mavx2 -c -o jody_hash_simd.o jody_hash_simd.c

jody_hash_avx2.o: jody_hash_simd.o
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -mavx2 -c -o jody_hash_avx2.o jody_hash_avx2.c

jody_hash_sse2.o: jody_hash_simd.o
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) $(CPPFLAGS) -msse2 -c -o jody_hash_sse2.o jody_hash_sse2.c

apiver: helper_code/libjodycode_apiver.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -o apiver helper_code/libjodycode_apiver.c

vercheck: helper_code/libjodycode_check.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -DJC_TEST -I. -c -o vercheck.o helper_code/libjodycode_check.c
	$(CC) $(CFLAGS) $(COMPILER_OPTIONS) $(WIN_CFLAGS) $(CFLAGS_EXTRA) -I. -L. -Wl,-Bstatic vercheck.o -ljodycode -Wl,-Bdynamic -o vercheck

cacheinfo:
	$(CC) cacheinfo.c -DJC_TEST $(CFLAGS) $(LDFLAGS) -o cacheinfo

lnk: tests/linkfiles_dedupe.c
	$(CC) -Wall -Wextra -pedantic $(CFLAGS) $(LDFLAGS) -I. -std=gnu11 tests/linkfiles_dedupe.c libjodycode.a -o lnk

.c.o:
	$(CC) -c $(COMPILER_OPTIONS) $(CFLAGS) $(CPPFLAGS) $< -o $@

#manual:
#	gzip -9 < jodycode.8 > jodycode.8.gz

$(PROGRAM_NAME): jodyhash $(OBJS)
#	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)

winres.o: winres.rc winres.manifest.xml
	./tune_winres.sh
	windres winres.rc winres.o

winres_xp.o: winres_xp.rc
	./tune_winres.sh
	windres winres_xp.rc winres_xp.o

installdirs:
	test -e $(DESTDIR)$(LIB_DIR) || $(MKDIR) $(DESTDIR)$(LIB_DIR)
	test -e $(DESTDIR)$(INC_DIR) || $(MKDIR) $(DESTDIR)$(INC_DIR)
	test -e $(DESTDIR)$(MAN7_DIR) || $(MKDIR) $(DESTDIR)$(MAN7_DIR)

installfiles: installdirs
	$(INSTALL_PROGRAM) $(PROGRAM_NAME)$(SO_VER_FULL) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_FULL)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_FULL) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_MAJOR)
	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_SUFFIX)
	$(INSTALL_DATA) $(PROGRAM_NAME)$(LIB_SUFFIX)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(LIB_SUFFIX)
	$(INSTALL_DATA) $(PROGRAM_NAME).h  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
	$(INSTALL_DATA) $(PROGRAM_NAME).7  $(DESTDIR)$(MAN7_DIR)/$(PROGRAM_NAME).7

install: installdirs installfiles

uninstalldirs:
	-test -e $(DESTDIR)$(LIB_DIR)  && $(RMDIR) $(DESTDIR)$(LIB_DIR)
	-test -e $(DESTDIR)$(INC_DIR)  && $(RMDIR) $(DESTDIR)$(INC_DIR)
	-test -e $(DESTDIR)$(MAN7_DIR) && $(RMDIR) $(DESTDIR)$(MAN7_DIR)

uninstallfiles:
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_FULL)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_MAJOR)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_SUFFIX)
	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(LIB_SUFFIX)
	$(RM)  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
	$(RM)  $(DESTDIR)$(MAN7_DIR)/$(PROGRAM_NAME).7

uninstall: uninstallfiles uninstalldirs

test:
	./test.sh

stripped: sharedlib staticlib
	$(STRIP_UNNEEDED) libjodycode$(SO_SUFFIX)
	$(STRIP_DEBUG) libjodycode$(LIB_SUFFIX)

objsclean:
	$(RM) $(OBJS) $(SIMD_OBJS) vercheck.o *.obj

clean: objsclean
	$(RM) $(PROGRAM_NAME)$(SO_SUFFIX) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(PROGRAM_NAME)$(SO_VER_FULL)
	$(RM) $(PROGRAM_NAME)$(LIB_SUFFIX) apiver cacheinfo vercheck
	$(RM) *~ helper_code/*~ libjodycode.a libjodycode.so.* libjodycode.dll.* .*.un~ *.gcno *.gcda *.gcov

distclean: objsclean clean
	$(RM) *.pkg.tar.*
	$(RM) -r $(PROGRAM_NAME)-*-*/ $(PROGRAM_NAME)-*-*.zip

chrootpackage:
	+./chroot_build.sh
package:
	+./generate_packages.sh

=== debian/changelog ===
libjodycode (4.0.1-7~bpo13+1) trixie-backports; urgency=medium

  * Rebuild for trixie-backports.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 04 Oct 2025 16:47:52 -0300

libjodycode (4.0.1-7) unstable; urgency=medium

  * debian/tests/control: updated dependencies in CI tests.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 29 Sep 2025 20:40:30 -0300

libjodycode (4.0.1-6) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 28 Sep 2025 14:19:23 -0300

libjodycode (4.0.1-5) experimental; urgency=medium

  * debian/libjodycode4.symbols: adjusted some symbols for hurd-*.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sat, 27 Sep 2025 15:03:23 -0300

libjodycode (4.0.1-4) experimental; urgency=medium

  * Using libjodycode4 instead of libjodycode4t64. Thanks to Sebastian Ramacher
    <sramacher@debian.org> for the guidance. Consequently:
      - debian/control:
          ~ Changed from libjodycode4t64 to libjodycode4 in the binary name.
          ~ Dropped the Provides field.
          ~ Updated Replaces, Brakes and Depends fields.
      - debian/libjodycode4t64.docs: renamed to debian/libjodycode4.docs.
      - debian/libjodycode4t64.install: renamed to debian/libjodycode4.install.
      - debian/libjodycode4t64.symbols: renamed to debian/libjodycode4.symbols.
      - debian/libjodycode4.symbols: updated the header.
      - Closes: #1116297

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Thu, 25 Sep 2025 08:11:57 -0300

libjodycode (4.0.1-3) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 23 Sep 2025 20:16:45 -0300

libjodycode (4.0.1-2) experimental; urgency=medium

  * debian/libjodycode4t64.symbols: set a symbol for Linux only to avoid a
    FTBFS on Hurd.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 23 Sep 2025 12:33:10 -0300

libjodycode (4.0.1-1) experimental; urgency=medium

  * New upstream version 4.0.1.
  * Replaced libjodycode3t64 by libjodycode4t64. Consequently:
      - debian/control:
          ~ Renamed the binary name.
          ~ Updated Depends, Replaces and Breaks fields.
      - debian/libjodycode3t64.docs: renamed to debian/libjodycode4t64.docs.
      - debian/libjodycode3t64.install: renamed to libjodycode4t64.install.
      - debian/libjodycode3t64.symbols: renamed to libjodycode4t64.symbols.
      - debian/libjodycode4t64.symbols: updated symbols.
  * debian/control: removed no longer needed "Rules-Requires-Root: no" field.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Sun, 21 Sep 2025 13:50:01 -0300

libjodycode (3.1.2-1) unstable; urgency=medium

  * New upstream version 3.1.2.
  * debian/control: bumped Standards-Version to 4.7.2.
  * debian/copyright: updated upstream and packaging copyright years.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 25 Mar 2025 22:11:15 -0300

=== debian/control ===
--- 
+++ 
@@ -2,20 +2,18 @@
 Section: libs
 Priority: optional
 Maintainer: Joao Eriberto Mota Filho <eriberto@debian.org>
-Rules-Requires-Root: no
 Build-Depends: dpkg-dev (>= 1.22.5), debhelper-compat (= 13)
 Standards-Version: 4.7.2
 Homepage: https://codeberg.org/jbruchon/libjodycode
 Vcs-Browser: https://salsa.debian.org/debian/libjodycode
 Vcs-Git: https://salsa.debian.org/debian/libjodycode.git
 
-Package: libjodycode3t64
-Provides: ${t64:Provides}
+Package: libjodycode4
 Architecture: any
 Multi-Arch: same
 Depends: ${shlibs:Depends}, ${misc:Depends}
-Replaces: libjodycode3, libjodycode2 (<= 2.0.1-4)
-Breaks: libjodycode3 (<< ${source:Version}), libjodycode2 (<= 2.0.1-4)
+Replaces: libjodycode4t64, libjodycode3t64, libjodycode3, libjodycode2 (<= 2.0.1-4)
+Breaks: libjodycode4t64, libjodycode3t64, libjodycode3 (<< ${source:Version}), libjodycode2 (<= 2.0.1-4)
 Description: shared lib for programs written by Jody Bruchon (runtime)
  libjodycode is a software code library containing code shared among several
  of the programs written by Jody Bruchon such as imagepile, jdupes, winregfs,
@@ -30,7 +28,7 @@
 Architecture: any
 Multi-Arch: same
 Section: libdevel
-Depends: ${misc:Depends}, libjodycode3t64 (= ${binary:Version})
+Depends: ${misc:Depends}, libjodycode4 (= ${binary:Version})
 Replaces: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
 Breaks: libjodycode2-dev (<= 2.0.1-4), libjodycode3-dev (<= 3.0.1-2)
 Description: shared lib for programs written by Jody Bruchon (development files)

=== debian/watch ===
version=4
https://codeberg.org/jbruchon/libjodycode/tags archive/v?(\d\S+)\.tar\.(?:bz2|gz|xz)

## libjodycode 4.1

=== Makefile ===
--- 
+++ 
@@ -6,7 +6,7 @@
 LIB_DIR ?= $(PREFIX)/lib
 INC_DIR ?= $(PREFIX)/include
 MAN_BASE_DIR ?= $(PREFIX)/share/man
-MAN7_DIR ?= $(MAN_BASE_DIR)/man7
+MAN3_DIR ?= $(MAN_BASE_DIR)/man3
 CC ?= gcc
 INSTALL = install
 RM      = rm -f
@@ -21,14 +21,14 @@
 # Make Configuration
 COMPILER_OPTIONS = -Wall -Wwrite-strings -Wcast-align -Wstrict-aliasing -Wstrict-prototypes -Wpointer-arith -Wundef
 COMPILER_OPTIONS += -Wshadow -Wfloat-equal -Waggregate-return -Wcast-qual -Wswitch-default -Wswitch-enum -Wconversion -Wunreachable-code -Wformat=2
-COMPILER_OPTIONS += -std=gnu11 -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe -fPIC
+COMPILER_OPTIONS += -D_FILE_OFFSET_BITS=64 -fstrict-aliasing -pipe -fPIC
 
 UNAME_S       = $(shell uname -s)
 UNAME_M       = $(shell uname -m)
 VERSION       = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/".*//')
 VERSION_MAJOR = $(shell grep -m 1 '^.define LIBJODYCODE_VER ' libjodycode.h | sed 's/[^"]*"//;s/\..*//')
-SO_VER_FULL   =$(SO_SUFFIX).$(VERSION)
-SO_VER_MAJOR  =$(SO_SUFFIX).$(VERSION_MAJOR)
+SO_VER_FULL   = $(SO_SUFFIX).$(VERSION)
+SO_VER_MAJOR  = $(SO_SUFFIX).$(VERSION_MAJOR)
 CROSS_DETECT  = $(shell true | $(CC) -dM -E - | grep -m 1 __x86_64 || echo "cross")
 
 # Are we running on a Windows OS?
@@ -62,6 +62,14 @@
  COMPILER_OPTIONS += -Wextra -Wstrict-overflow=5 -Winit-self
 endif
 
+# C standard selection
+ifndef USE_C99
+COMPILER_OPTIONS += -std=gnu11
+else
+COMPILER_OPTIONS += -std=gnu99
+OBJS += c99_aligned_alloc.o
+endif
+
 # Debugging code inclusion
 ifdef LOUD
  DEBUG=1
@@ -129,10 +137,10 @@
 OBJS += error.o fopen.o jc_fwprint.o getcwd.o jody_hash.o link.o
 OBJS += linkfiles.o numstrcmp.o oom.o paths.o
 OBJS += remove.o rename.o size_suffix.o stat.o
-OBJS += string.o time.o version.o win_unicode.o
+OBJS += string.o str_t.o time.o version.o win_unicode.o
 OBJS += $(ADDITIONAL_OBJECTS)
 
-all: sharedlib staticlib
+all: manual sharedlib staticlib
 	-@test "$(CROSS_DETECT)" = "cross" && echo "NOTICE: SIMD disabled: !x86_64 or a cross-compiler detected (CC = $(CC))" || true
 
 sharedlib: $(OBJS) $(SIMD_OBJS)
@@ -168,11 +176,8 @@
 .c.o:
 	$(CC) -c $(COMPILER_OPTIONS) $(CFLAGS) $(CPPFLAGS) $< -o $@
 
-#manual:
-#	gzip -9 < jodycode.8 > jodycode.8.gz
-
-$(PROGRAM_NAME): jodyhash $(OBJS)
-#	$(CC) $(CFLAGS) $(LDFLAGS) -o $(PROGRAM_NAME) $(OBJS)
+manual:
+	gzip -9 < libjodycode.3 > libjodycode.3.gz
 
 winres.o: winres.rc winres.manifest.xml
 	./tune_winres.sh
@@ -185,22 +190,22 @@
 installdirs:
 	test -e $(DESTDIR)$(LIB_DIR) || $(MKDIR) $(DESTDIR)$(LIB_DIR)
 	test -e $(DESTDIR)$(INC_DIR) || $(MKDIR) $(DESTDIR)$(INC_DIR)
-	test -e $(DESTDIR)$(MAN7_DIR) || $(MKDIR) $(DESTDIR)$(MAN7_DIR)
+	test -e $(DESTDIR)$(MAN3_DIR) || $(MKDIR) $(DESTDIR)$(MAN3_DIR)
 
 installfiles: installdirs
 	$(INSTALL_PROGRAM) $(PROGRAM_NAME)$(SO_VER_FULL) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_FULL)
 	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_FULL) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_MAJOR)
 	-test "$(ON_WINDOWS)" != "1" && $(LN) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_SUFFIX)
 	$(INSTALL_DATA) $(PROGRAM_NAME)$(LIB_SUFFIX)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(LIB_SUFFIX)
-	$(INSTALL_DATA) $(PROGRAM_NAME).h  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
-	$(INSTALL_DATA) $(PROGRAM_NAME).7  $(DESTDIR)$(MAN7_DIR)/$(PROGRAM_NAME).7
+	$(INSTALL_DATA) $(PROGRAM_NAME).h $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
+	$(INSTALL_DATA) $(PROGRAM_NAME).3.gz $(DESTDIR)$(MAN3_DIR)/$(PROGRAM_NAME).3.gz
 
 install: installdirs installfiles
 
 uninstalldirs:
 	-test -e $(DESTDIR)$(LIB_DIR)  && $(RMDIR) $(DESTDIR)$(LIB_DIR)
 	-test -e $(DESTDIR)$(INC_DIR)  && $(RMDIR) $(DESTDIR)$(INC_DIR)
-	-test -e $(DESTDIR)$(MAN7_DIR) && $(RMDIR) $(DESTDIR)$(MAN7_DIR)
+	-test -e $(DESTDIR)$(MAN3_DIR) && $(RMDIR) $(DESTDIR)$(MAN3_DIR)
 
 uninstallfiles:
 	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_VER_FULL)
@@ -208,7 +213,7 @@
 	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(SO_SUFFIX)
 	$(RM)  $(DESTDIR)$(LIB_DIR)/$(PROGRAM_NAME)$(LIB_SUFFIX)
 	$(RM)  $(DESTDIR)$(INC_DIR)/$(PROGRAM_NAME).h
-	$(RM)  $(DESTDIR)$(MAN7_DIR)/$(PROGRAM_NAME).7
+	$(RM)  $(DESTDIR)$(MAN3_DIR)/$(PROGRAM_NAME).3.gz
 
 uninstall: uninstallfiles uninstalldirs
 
@@ -224,7 +229,7 @@
 
 clean: objsclean
 	$(RM) $(PROGRAM_NAME)$(SO_SUFFIX) $(PROGRAM_NAME)$(SO_VER_MAJOR) $(PROGRAM_NAME)$(SO_VER_FULL)
-	$(RM) $(PROGRAM_NAME)$(LIB_SUFFIX) apiver cacheinfo vercheck
+	$(RM) $(PROGRAM_NAME)$(LIB_SUFFIX) apiver cacheinfo vercheck $(PROGRAM_NAME).3.gz
 	$(RM) *~ helper_code/*~ libjodycode.a libjodycode.so.* libjodycode.dll.* .*.un~ *.gcno *.gcda *.gcov
 
 distclean: objsclean clean

=== debian/changelog ===
libjodycode (4.1-2) unstable; urgency=medium

  * Upload to unstable.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 14 Oct 2025 16:48:07 -0300

libjodycode (4.1-1) experimental; urgency=medium

  * New upstream version 4.1.
  * debian/libjodycode4.symbols: added new symbols.
  * debian/patches/:
      - 010_fix-FTBFS.patch: created to fix a FTBFS. Thanks to Jody Bruchon
        <jody@jodybruchon.com>.
      - 020_fix-manpage-level.patch: created to change level from 7 to 3.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Tue, 14 Oct 2025 00:04:02 -0300

libjodycode (4.0.1-8) unstable; urgency=medium

  [ Joao Eriberto Mota Filho ]
  * debian/copyright: added rights for Sebastian Ramacher
    <sramacher@debian.org>.
  * debian/tests/: added 3 new CI tests, from jdupes package, to
    check the bugs #1030933 and #1063079.

  [ Sebastian Ramacher ]
  * Moved devel manpage to -dev package to make libjodycode{3,4,...}
    co-installable. Consequently:
      - debian/libjodycode-dev.install: removed usr/share.
      - debian/libjodycode4.install: added usr/share.
  * debian/control: removed no longer necessary Breaks+Replaces.

 -- Joao Eriberto Mota Filho <eriberto@debian.org>  Mon, 06 Oct 2025 03:54:48 -0300
